/*
 * nlmimp.c
 * Copyright (c) 2000 Martin Hinner <mhi@penguin.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

#include "nlm.h"

int 
main (int argc, char **argv)
{
  int fd;
  FILE *imp;
  struct nlm_header hdr;
  unsigned char symlen;
  char symbol[0x100];
  unsigned long address;
  int i;
  char hostname[0x100];

  if (argc != 3)
    {
      fprintf (stderr, "Invalid arguments\n");
      exit (1);
    }

  fd = open (argv[1], O_RDONLY);
  if (fd < 0)
    {
      perror (argv[1]);
      exit (1);
    }


  if (read (fd, &hdr, sizeof (hdr)) != sizeof (hdr))
    {
      perror ("NLM Header");
      close (fd);
      exit (1);
    }

  imp = fopen (argv[2], "wt");
  if (imp == NULL)
    {
      perror (argv[2]);
      exit (1);
    }

  gethostname (hostname, 0x100);
  fprintf (imp, "#\n");
  fprintf (imp, "# This file was automatically generated by nlmimp(1) program.\n");
  fprintf (imp, "# Source NLM:     %s\n", argv[1]);
  fprintf (imp, "# Author:         %s@%s\n", getenv ("LOGNAME"), hostname);
  fprintf (imp, "#\n");

  lseek (fd, hdr.publicsOffset, SEEK_SET);

  for (i = 0; i < hdr.numberOfPublics; i++)
    {
      read (fd, &symlen, 1);
      read (fd, symbol, symlen);
      symbol[symlen] = 0;
      read (fd, &address, sizeof (address));
      fprintf (imp, " %s", symbol);
      if (i == hdr.numberOfPublics - 1)
	fprintf (imp, "\n");
      else
	fprintf (imp, ",\n");
    }

  fclose (imp);
  close (fd);

  return 0;
}
